错误和异常

2017-09-28 0 By admin

python中常见的两种错误:语法错误和异常(exceptions)

语法错误:由语法分析器指出错误行,抛出一个SyntaxError错误;并提供错误的文件名和行号。

异常:即使python的语法书写正确,在执行过程中依然有可能会引发错误。运行期检查的错误成为“异常”,程序不会无条件的崩溃。

  • 异常位置:以堆栈的形式列出异常发生的位置;
  • 异常类型:作为异常的内置名显示;是内置标识;
  • 详细说明:显示在异常类型的后面,它的内容依赖于异常类型;

异常处理

在编程过程中可以预定好对不同异常的处理方法。
try…except…else…finally

try 语句按如下方式工作:

  • 首先,执行 try 子句 (在 try 和 except 关键字之间的部分)。
  • 如果没有异常发生, except 子句 在 try 语句执行完毕后就被忽略了。
  • 如果在 try 子句执行过程中发生了异常,那么该子句其余的部分就会被忽略。如果异常匹配于 except 关键字后面指定的异常类型,就执行对应的except子句。然后继续执行 try 语句之后的代码。
  • 如果发生了一个异常,在 except 子句中没有与之匹配的分支,它就会传递到上一级 try 语句中。

细节:

  • 如果最终仍找不到对应的处理语句,它就成为一个“未处理异常”,终止程序运行,显示提示信息。
  • 一个 try 语句可能包含多个 except 子句,分别指定处理不同的异常。至多只会有一个分支被执行。
  • 最后一个 except 子句可以省略异常名称,以作为通配符使用。
  • try … except 语句可以带有一个 else子句,该子句只能出现在所有 except 子句之后。当 try 语句没有抛出异常时,需要执行一些代码,可以使用这个子句。使用 else 子句比在 try 子句中附加代码要好,因为这样可以避免 try … except 意外的截获本来不属于它们保护的那些代码抛出的异常。
  • 在异常名(列表)之后,也可以为 except 子句指定一个变量。这个变量绑定于一个异常实例,它存储在 instance.args 的参数中。

例:
….try:
…….raise Exception(‘spam’, ‘eggs’)
….except Exception as inst: #except Exception,inst:
…….print(type(inst)) # the exception instance
…….print(inst.args) # arguments stored in .args
…….print(inst) # __str__ allows args to be printed directly,
……. # but may be overridden in exception subclasses
…….x, y = inst.args # unpack args
…….print(‘x =’, x)
…….print(‘y =’, y)

<class ‘Exception’>
(‘spam’, ‘eggs’)
(‘spam’, ‘eggs’)
x = spam
y = eggs

其他对异常实例的处理
1、str(inst)
返回字符串类型,只给出异常信息,不包括异常信息的类型,如1/0的异常信息
‘integer division or modulo by zero’
2、repr(inst)
给出较全的异常信息,包括异常信息的类型,如1/0的异常信息
“ZeroDivisionError(‘integer division or modulo by zero’,)”
3、inst.message
获得的信息同str(e)

抛出异常
raise 语句允许程序员强制抛出一个指定的异常。
语法:
raise 异常类型(‘详细说明’)
raise NameError(‘HiThere’)

自定义异常
这个暂时用不着,后续更新

自定义清理行为

  • try语句还有另一个可选的子句,目的在于定义在任何情况下都一定要执行的功能
  • 不管有没有发生异常,finally子句 在程序离开 try 后都一定会被执行。
  • 当 try 语句中发生了未被 except 捕获的异常(或者它发生在 except 或 else 子句中),在 finally 子句执行完后它会被重新抛出。
  • try 语句经由 break ,continue 或 return 语句退出也一样会执行 finally 子句。
  • 在真实场景的应用程序中,finally 子句用于释放外部资源(文件或网络连接之类的),无论它们的使用过程中是否出错。

异常标志和说明

BaseException 所有异常的基类
SystemExit 解释器请求退出
KeyboardInterrupt 用户中断执行(通常是输入^C)
Exception 常规错误的基类
StopIteration 迭代器没有更多的值
GeneratorExit 生成器(generator)发生异常来通知退出
StandardError 所有的内建标准异常的基类
ArithmeticError 所有数值计算错误的基类
FloatingPointError 浮点计算错误
OverflowError 数值运算超出最大限制
ZeroDivisionError 除(或取模)零 (所有数据类型)
AssertionError 断言语句失败
AttributeError 对象没有这个属性
EOFError 没有内建输入,到达EOF 标记
EnvironmentError 操作系统错误的基类
IOError 输入/输出操作失败
OSError 操作系统错误
WindowsError 系统调用失败
ImportError 导入模块/对象失败
LookupError 无效数据查询的基类
IndexError 序列中没有此索引(index)
KeyError 映射中没有这个键
MemoryError 内存溢出错误(对于Python 解释器不是致命的)
NameError 未声明/初始化对象 (没有属性)
UnboundLocalError 访问未初始化的本地变量
ReferenceError 弱引用(Weak reference)试图访问已经垃圾回收了的对象
RuntimeError 一般的运行时错误
NotImplementedError 尚未实现的方法
SyntaxError Python 语法错误
IndentationError 缩进错误
TabError Tab 和空格混用
SystemError 一般的解释器系统错误
TypeError 对类型无效的操作
ValueError 传入无效的参数
UnicodeError Unicode 相关的错误
UnicodeDecodeError Unicode 解码时的错误
UnicodeEncodeError Unicode 编码时错误
UnicodeTranslateError Unicode 转换时错误
Warning 警告的基类
DeprecationWarning 关于被弃用的特征的警告
FutureWarning 关于构造将来语义会有改变的警告
OverflowWarning 旧的关于自动提升为长整型(long)的警告
PendingDeprecationWarning 关于特性将会被废弃的警告
RuntimeWarning 可疑的运行时行为(runtime behavior)的警告
SyntaxWarning 可疑的语法的警告
UserWarning 用户代码生成的警告